// TsTable.h: TSe[ubp[NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSTABLE_H_)
#define _TSTABLE_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "MediaData.h"
#include "TsStream.h"
#include "TsDescriptor.h"

using std::vector;


/////////////////////////////////////////////////////////////////////////////
// PSIe[uۉNX
/////////////////////////////////////////////////////////////////////////////

class CPsiTable
{
public:
	CPsiTable();
	CPsiTable(const CPsiTable &Operand);

	CPsiTable & operator = (const CPsiTable &Operand);

	const bool StoreSection(const CPsiSection *pSection, bool *pbUpdate = NULL);

	const WORD GetExtensionNum(void) const;
	const bool GetExtension(const WORD wIndex, WORD *pwExtension) const;
	const bool GetSectionNum(const WORD wIndex, WORD *pwSectionNum) const;
	const CMediaData * GetSectionData(const WORD wIndex = 0, const BYTE bySectionNo = 0) const;

	void Reset(void);

protected:
	struct TAG_TABLEITEM
	{
		WORD wTableIdExtension;				// e[uIDg
		WORD wSectionNum;					// ZNV
		BYTE byVersionNo;					// o[Wԍ
		vector<CMediaData> SectionArray;	// ZNVf[^
	};

	vector<TAG_TABLEITEM> m_TableArray;		// e[u
};


/////////////////////////////////////////////////////////////////////////////
// PSIe[uZbgۉNX
/////////////////////////////////////////////////////////////////////////////

class CPsiTableSuite
{
public:
	CPsiTableSuite();
	CPsiTableSuite(const CPsiTableSuite &Operand);

	CPsiTableSuite & operator = (const CPsiTableSuite &Operand);

	const bool StorePacket(const CTsPacket *pPacket);

	void SetTargetSectionExt(const bool bTargetExt);
	const bool AddTable(const BYTE byTableID);

	const WORD GetIndexByID(const BYTE byTableID);
	const CPsiTable * GetTable(const WORD wIndex = 0) const;
	const CMediaData * GetSectionData(const WORD wIndex = 0, const WORD wSubIndex = 0, const BYTE bySectionNo = 0) const;

	const DWORD GetCrcErrorCount(void) const;
	void Reset(void);

protected:
	struct TAG_TABLESET
	{
		BYTE byTableID;						// e[uID
		CPsiTable PsiTable;					// e[u
	};

	static void CALLBACK StoreSection(const CPsiSection *pSection, const PVOID pParam);

	vector<TAG_TABLESET> m_TableSet;		// e[uZbg

	bool m_bTargetSectionExt;
	bool m_bTableUpdated;

private:
	CPsiSectionParser m_PsiSectionParser;
};


/////////////////////////////////////////////////////////////////////////////
// PATe[uۉNX
/////////////////////////////////////////////////////////////////////////////

class CPatTable : public CPsiTableSuite
{
public:
	CPatTable();

	const bool StorePacket(const CTsPacket *pPacket);

	const bool IsNitPacket(const CTsPacket *pPacket);
	const bool IsPmtPacket(const CTsPacket *pPacket);
	const WORD GetNitPID(const WORD wIndex = 0) const;
	const WORD GetNitNum(void) const;
	const WORD GetPmtPID(const WORD wIndex = 0) const;
	const WORD GetPmtNum(void) const;

	void Reset(void);

protected:
	struct TAG_PATITEM
	{
		WORD wProgramID;	// ԑgԍID
		WORD wPID;			// NIT or PMTPID
	};

	const bool ParseTable(const BYTE *pHexData, const WORD wDataSize);

	vector<TAG_PATITEM> m_NitPIDArray;
	vector<TAG_PATITEM> m_PmtPIDArray;
};


/////////////////////////////////////////////////////////////////////////////
// PMTe[uۉNX
/////////////////////////////////////////////////////////////////////////////

class CPmtTable : public CPsiTableSuite
{
public:
	CPmtTable();
	CPmtTable(const CPmtTable &Operand);

	CPmtTable & operator = (const CPmtTable &Operand);

	const bool StorePacket(const CTsPacket *pPacket);

	const WORD GetPcrPID(void) const;
	const CCaMethodDesc * GetCaMethodDesc(void) const;
	const WORD GetEsInfoNum(void) const;
	const BYTE GetStreamTypeID(const WORD wIndex) const;
	const WORD GetEsPID(const WORD wIndex) const;
	const CStreamIdDesc * GetStreamIdDesc(const WORD wIndex) const;
	const bool IsEsPID(const WORD wPID) const;

	void Reset(void);

protected:
	struct TAG_PMTITEM
	{
		BYTE byStreamTypeID;			// Stream Type ID
		WORD wEsPID;					// Elementary Stream PID
		CStreamIdDesc m_StreamIdDesc;	// Stream ID Descriptor
	};

	const bool ParseTable(const BYTE *pHexData, const WORD wDataSize);

	WORD m_wPcrPID;						// PCR_PID
	CCaMethodDesc m_CaMethodDesc;		// Conditional Access Method Descriptor

	vector<TAG_PMTITEM> m_EsInfoArray;
};


#endif // !defined(_TSTABLE_H_)
